## nvidia-graphics-drivers-tesla-550 550.54.15

=== debian/changelog ===
nvidia-graphics-drivers-tesla-550 (550.54.15-3) unstable; urgency=medium

  [ Andreas Beckmann ]
  * Backport drm_fb_create_takes_format_info changes from 535.274.02 to fix
    kernel module build for Linux 6.17.
  * Backport iommu_dev_enable_feature changes from 535.261.03 to fix open
    kernel module build for Linux 6.16.

  [ Luca Boccassi ]
  * Remove myself from Uploaders.

 -- Andreas Beckmann <anbe@debian.org>  Sun, 09 Nov 2025 00:11:58 +0100

nvidia-graphics-drivers-tesla-550 (550.54.15-2) unstable; urgency=medium

  * Backport drm_connector_helper_funcs_mode_valid_has_const_mode_arg changes
    from 550.163.01 and ccflags-y, nv_timer_delete_sync, __iowrite64_lo_hi,
    page_pgmap and make_device_exclusive changes from 570.153.02 and
    nv_vma_start_write changes from 570.169 to fix kernel module build for
    Linux 6.15.

 -- Andreas Beckmann <anbe@debian.org>  Tue, 24 Jun 2025 11:20:03 +0200

nvidia-graphics-drivers-tesla-550 (550.54.15-1) unstable; urgency=medium

  * Fork as new source package, rename everything to include '-tesla-550'.
  * Upload to unstable.

 -- Andreas Beckmann <anbe@debian.org>  Tue, 29 Apr 2025 18:35:04 +0200

nvidia-graphics-drivers (550.54.15-1) experimental; urgency=medium

  * New upstream Tesla branch release 550.54.15 (2024-03-18).
    * This is the last driver release supporting the ppc64el architecture.
  * New upstream production and Tesla branch release 550.54.14 (2024-02-23).
    * Fixed CVE-2024-0074, CVE-2024-0075, CVE-2024-0078.  (Closes: #1064983)
      https://nvidia.custhelp.com/app/answers/detail/a_id/5520
    - Fixed a bug that caused HDMI FRL displays to flicker or blank when
      enabling VRR with 8 bits per color channel.
    - Fixed a regression introduced with the 550.40.07 beta driver which
      caused corrupted window decorations in some applications when running
      on GNOME.
    - Fixed a bug where vkAcquireNextImageKHR() was not returning
      VK_ERROR_OUT_OF_DATE_KHR when it should with WSI X11 swapchains.
    - Fixed a bug where fences passed to VkSwapchainPresentFenceInfoEXT could
      signal earlier than expected when a WSI X11 swapchain becomes out of date.
    - Fixed Xid errors on Hogwarts Legacy and Forza Horizon 4.
    * Improved compatibility with recent Linux kernels.
  * New upstream release 535 series.
    - Fixed a regression which prevented some Vulkan applications from
      receiving VK_DEVICE_LOST upon a VT switch, which could lead to the
      application hanging or behaving incorrectly.

  [ Andreas Beckmann ]
  * Merge changes from 535.161.08-3.  (Closes: #1072722)
  * Refresh patches.
  * Update nv-readme.ids.
  * Update symbols files.
  * libcuda1: Add Provides: libcuda-12.4-1.

 -- Andreas Beckmann <anbe@debian.org>  Tue, 29 Apr 2025 09:15:30 +0200

nvidia-graphics-drivers (550.40.07-1) experimental; urgency=medium

  * New upstream beta 550.40.07 (2024-01-24).
    - Fixed an issue that sometimes caused Wayland applications to run at less
      than one frame per second on Maxwell, Volta, and Pascal series GPUs.
    - Added support for the VK_KHR_video_encode_queue,
      VK_KHR_video_encode_h264, VK_KHR_video_encode_h265 and
      VK_KHR_video_maintenance1 extensions.
    - Fixed a bug that caused an intermittent drop in desktop framerate.
    - Fixed a bug that caused "Flip event timeout" messages to be printed to the
      system log when displays are hotplugged when nvidia-drm is loaded with the
      `fbdev=1` kernel module parameter.
    - Fixed intermittent Xid errors on Horizon Zero Dawn, Metro Exodus,
      Forza Horizon 5, and Halo Infinite.
    - Fixed a bug which prevented the "NoMaxPClkCheck" mode validation token
      from working on single-link TMDS (e.g. DVI, HDMI) outputs.
    - Fixed a bug that allowed VRR displays to be driven below their minimum
      refresh rate, resulting in a blank or flickering image.
    - Added an application profile to improve Kwin performance on hybrid GPU
      systems by setting OGL_DEDICATED_HW_STATE_PER_CONTEXT=ENABLE_ROBUST.
    - Updated the build process for NVIDIA kernel modules to honor the
      INSTALL_MOD_DIR Kbuild environment variable.
    - Added support for R8, GR88 and YCbCr GBM formats.
    - Optimized the X driver headless framerate limiter to more closely mimic
      upstream behavior and prevent it from activating in inconvenient
      situations. Added a new X config option "LimitFrameRateWhenHeadless" to
      disable the headless framerate limiter.
    - Fixed a bug that prevented Gamescope from running when using the NVIDIA
      Open GPU Kernel modules.
    - Use transparent huge pages for OpenGL/Vulkan when available for the .text
      section. This is done through madvise() calls, and requires a Linux kernel
      configured with CONFIG_READ_ONLY_THP_FOR_FS.
    * Improved compatibility with recent Linux kernels.

  [ Andreas Beckmann ]
  * Refresh patches.
  * Update nv-readme.ids.
  * Update symbols files.
  * nvidia-powerd is now available on arm64.
  * Update lintian overrides.

 -- Andreas Beckmann <anbe@debian.org>  Wed, 23 Apr 2025 07:23:08 +0200

nvidia-graphics-drivers (545.29.06-1) experimental; urgency=medium

  * New upstream new feature branch release 545.29.06 (2023-11-22).
    - Fixed a regression that prevented setting backlight brightness levels.
    - Fixed a bug that caused games built on the Source 2 engine to hang
      when running under Xwayland.
  * New upstream new feature branch release 545.29.02 (2023-10-31).
    * Fixed CVE-2023-31022.  (Closes: #1055136)
      https://nvidia.custhelp.com/app/answers/detail/a_id/5491

  [ Andreas Beckmann ]
  * Refresh patches.

 -- Andreas Beckmann <anbe@debian.org>  Tue, 15 Apr 2025 22:15:51 +0200

nvidia-graphics-drivers (545.23.06-6) experimental; urgency=medium

  * Backport drm_driver_has_date changes from 570.124.04 to fix kernel module
    build for Linux 6.14.
  * Backport crypto_akcipher_verify changes from 550.144.03 to fix open kernel

