=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

include /usr/share/dpkg/architecture.mk
include /usr/share/dpkg/pkg-info.mk

NVIDIA_RELEASE		 = $(DEB_VERSION_UPSTREAM)
NVIDIA_MAJOR		 = $(firstword $(subst ., ,$(NVIDIA_RELEASE)))
include debian/rules.defs
NVIDIA_TESLA		?=
WATCH_VERSION		?= $(NVIDIA_TESLA)
WATCH_PATTERN		?=
GIT_BRANCH		?= $(if $(variant),$(variant)/main,$(version_major))
XORG_ABI_LIST		?=
XORG_BOUND		?=
LINUX_KMOD_VARIANT	?=
LINUX_KMOD_TESTED	?=
NVIDIA_LEGACY_CHECK	?=
NVIDIA_SETTINGS		?= nvidia-settings$(-variant) (>= $(NVIDIA_MAJOR))
ARCH_CANDIDATES		?= amd64 i386 armhf arm64 ppc64el
ARCH_LIST		?= amd64
NO_DRIVER_ARCH_LIST	?=
NO_TARBALL_ARCH_LIST	?=
NO_AUTOPKGTEST_ARCH_LIST?=

version			 = $(NVIDIA_RELEASE)
version_major		 = $(NVIDIA_MAJOR)
variant			 = $(if $(NVIDIA_TESLA),tesla-$(NVIDIA_TESLA))
variant_description	 = $(if $(NVIDIA_TESLA), (Tesla $(NVIDIA_TESLA) version))
variant_description_short= $(if $(NVIDIA_TESLA), (Tesla $(NVIDIA_TESLA)))
-variant		 = $(if $(variant),-$(variant))
trailing_minus		 = $(if $(filter %0 %1 %2 %3 %4 %5 %6 %7 %8 %9,$(variant)),-)
nvidia			 = nvidia$(-variant)
nvidia-			 = $(nvidia)$(trailing_minus)
nvidia_if_variant	 = $(if $(variant),$(nvidia)-)
current			 = $(if $(variant),$(variant),current)
module-current		 = $(current)$(LINUX_KMOD_VARIANT)
module			 = nvidia-$(module-current)
nvidia-kernel		 = $(nvidia)$(LINUX_KMOD_VARIANT)-kernel
libcuda1		 = lib$(nvidia_if_variant)cuda1
watch_pattern		 = $(or $(WATCH_PATTERN),$(if $(WATCH_VERSION),$(WATCH_VERSION)(?:\.[\d\.\-]+)?),\d[\d\.\-]*)
debhelper_compat	:= $(shell sed -rn 's/.*debhelper-compat \(= ([0-9]+)\).*/\1/p' debian/control)
has_driver		 = $(filter $(DEB_HOST_ARCH),$(DRIVER_ARCH_LIST))
DRIVER_ARCH_LIST	 = $(filter-out $(NO_DRIVER_ARCH_LIST),$(ARCH_LIST))
TARBALL_ARCH_LIST	 = $(filter-out $(NO_TARBALL_ARCH_LIST),$(DRIVER_ARCH_LIST))
AUTOPKGTEST_ARCH_LIST	 = $(filter-out $(NO_AUTOPKGTEST_ARCH_LIST),$(DRIVER_ARCH_LIST))

# system libdir
libdir			?= usr/lib/$(DEB_HOST_MULTIARCH)
# nvidia version specific directory below $(libdir)
nvidia_private		 = nvidia/$(current)

CONTROL_PREFIXES	 = nvidia
CONTROL_PREFIXES	+= firmware-nvidia-gsp
CONTROL_PREFIXES	+= libnvidia
CONTROL_PREFIXES	+= libgl1-nvidia
CONTROL_PREFIXES	+= libglx-nvidia0
CONTROL_PREFIXES	+= libegl-nvidia0
CONTROL_PREFIXES	+= libgles-nvidia1 libgles-nvidia2
CONTROL_PREFIXES	+= libcuda1
CONTROL_PREFIXES	+= libcudadebugger1
CONTROL_PREFIXES	+= libnvcuvid1
CONTROL_PREFIXES	+= libnvoptix1
CONTROL_PREFIXES	+= xserver-xorg-video-nvidia
RENAME_libcuda1		 = $(libcuda1)
RENAME_libcudadebugger1	 = lib$(nvidia_if_variant)cudadebugger1
RENAME_libnvcuvid1	 = lib$(nvidia_if_variant)nvcuvid1
RENAME_libnvoptix1	 = lib$(nvidia_if_variant)nvoptix1
renamed_prefix		 = $(or $(RENAME_$1),$(subst nvidia,$(if $(filter %nvidia0 %nvidia1 %nvidia2,$1),$(nvidia-),$(nvidia)),$1))
CONTROL_PREFIXES_RENAMED = $(foreach p,$(CONTROL_PREFIXES),$(call renamed_prefix,$p))

# $1=file, $2=prefix
applyprefixrename	 = $(patsubst debian/$2%,debian/$(call renamed_prefix,$2)%,$1)
# $1=file, $2=prefixlist
applyprefixrenamelist	 = $(if $2,$(call applyprefixrenamelist,$(call applyprefixrename,$1,$(firstword $2)),$(wordlist 2,$(words $2),$2)),$1)

ALL_CONTROL	:= $(wildcard $(patsubst %,debian/%*,$(CONTROL_PREFIXES)))
LEGACY_CONTROL	:= $(wildcard $(patsubst %,debian/%*,$(CONTROL_PREFIXES_RENAMED)))
RENAME_CONTROL	 = $(filter-out $(LEGACY_CONTROL),$(ALL_CONTROL))
RENAMED_CONTROL	 = $(foreach f,$(RENAME_CONTROL),$(call applyprefixrenamelist,$f,$(CONTROL_PREFIXES)))

TEMPLATE_DIRS	 = debian
TEMPLATE_DIRS	+= debian/module/debian
TEMPLATE_DIRS	+= debian/detect
TEMPLATE_DIRS	+= debian/tests
TEMPLATES	:= $(filter-out %.modules.in,$(wildcard $(addsuffix /*.in,$(TEMPLATE_DIRS))))

AUTOGEN		 = $(TEMPLATES:.in=)
AUTOGEN		+= $(RENAMED_CONTROL:.in=)
AUTOGEN		+= debian/module/debian/bug-control
AUTOGEN		+= debian/module/debian/control.modules.in
AUTOGEN		+= debian/bug-control
AUTOGEN		+= debian/substvars
AUTOGEN		+= $(AUTOKEEP)
AUTOKEEP	 = debian/watch
AUTOKEEP	+= debian/tests/autopkgtest-pkg-dkms.conf
AUTOKEEP	+= debian/tests/control
AUTOKEEP	+= debian/control
AUTOCLEAN	 = $(filter-out $(AUTOKEEP),$(AUTOGEN))

empty		 =
space		 = $(empty) $(empty)
comma		 = ,
xorg_depends	 = $(foreach abi, $(XORG_ABI_LIST), xorg-video-abi-$(abi) |)
xorg_depends	+= $(comma) xserver-xorg-core $(XORG_BOUND)
xorg_provides	 = xorg-driver-video

deps_nvidia_kmod_binary	 = $${nvidia-kernel}-dkms (= $${binary:Version})                [$${nvidia:archlist:driver}] |
deps_nvidia_kmod_binary	+= $${nvidia-kernel}-$${nvidia:Version}                         [$${nvidia:archlist:driver}] |
#deps_nvidia_kmod_binary	+= $${nvidia}-open-kernel-$${nvidia:Version}                    [$${nvidia:archlist:driver}] |
deps_nvidia_kmod_binary	+= nvidia-open-kernel-$${nvidia:Version}                        [$${nvidia:archlist:driver}] |
deps_nvidia_kmod_source	 = $${nvidia-kernel}-dkms (>= $${nvidia:Version})               [$${nvidia:archlist:driver}] |
deps_nvidia_kmod_source	+= $${nvidia-kernel}-source (>= $${nvidia:Version})             [$${nvidia:archlist:driver}] |
#deps_nvidia_kmod_source	+= $${nvidia}-open-kernel-source (>= $${nvidia:Version})        [$${nvidia:archlist:driver}] |
deps_nvidia_kmod_source	+= nvidia-open-kernel-source (>= $${nvidia:Version})            [$${nvidia:archlist:driver}] |


.PHONY: autogen prepare patch
autogen: debian/control $(AUTOGEN)
prepare: autogen unpack-stamp
ifneq (,$(has_driver))
prepare: nvidia.ids compare-copyright-license
prepare: nvidia-open.ids
endif
patch: prepare

NVIDIA-Linux-%:
	sh $*/${NVIDIA_FILENAME_$*} --extract-only
	ln -s ${NVIDIA_DIRNAME_$*} $@
	gunzip $@/*.1.gz

ifneq (,$(filter i386,$(NO_DRIVER_ARCH_LIST)))
NVIDIA-Linux-i386: NVIDIA-Linux-amd64
	$(RM) -r $@
	cp -al $</32 $@
	cp -al $</*.icd $@
	cp -al $</*.json* $@
endif

ifneq (,$(filter armhf,$(NO_DRIVER_ARCH_LIST)))
NVIDIA-Linux-armhf: NVIDIA-Linux-amd64
	$(RM) -r $@
	mkdir $@
	cp -al $</*.json $@
endif

ifneq (,$(filter ppc64el,$(NO_DRIVER_ARCH_LIST)))
NVIDIA-Linux-ppc64el: NVIDIA-Linux-amd64
	$(RM) -r $@
	mkdir $@
	cp -al $</*.icd $@
	cp -al $</*.json* $@
endif

# Always unpack amd64, we need files from them.
unpack-stamp: NVIDIA-Linux-amd64
unpack-stamp: NVIDIA-Linux-$(DEB_HOST_ARCH)
	$(if $(filter $(DEB_HOST_ARCH),$(ARCH_LIST)),,$(error Architecture $(DEB_HOST_ARCH) unsupported.))
	dh_testdir
	$(RM) NVIDIA-Linux
	ln -s NVIDIA-Linux-$(DEB_HOST_ARCH) NVIDIA-Linux
ifneq (,$(has_driver))
	QUILT_PATCHES=debian/patches QUILT_SERIES=series-postunpack quilt --quiltrc /dev/null push -a || test $$? = 2
	# bashism is used on a few architectures only
	sed -i 's/==/=/g' NVIDIA-Linux/nvidia-bug-report.sh
endif
	ls -al
	touch $@

nv-readme.ids: unpack-stamp
	sed -r -n '/^Chapter [0-9]+\. GSP Firmware|^A1\. CURRENT NVIDIA GPUS|^A1\. NVIDIA GEFORCE GPUS/,/^Chapter|^Appendix|^Below/ s/^(.{41}|.{49}) ([0-9a-fA-F]{4})($$| .*)/10de\2/p' \
		NVIDIA-Linux/README.txt \
		| tr a-f A-F | sort -u > $@
	@set -e -x ; \
	if ! cmp -s debian/$@ $@ ; then \
		diff -u debian/$@ $@ || true ; \
		: "*** Supported PCI IDs have changed. See diff above. Aborting. ***"; \
		exit 1 ; \
	fi
ifneq (,$(variant:tesla=))
	@set -e -x ; \
	if ! cmp -s debian/detect/$(nvidia).ids $@ ; then \
		diff -u debian/detect/$(nvidia).ids $@ || true ; \
		: "*** Supported PCI IDs of the $(nvidia) variant have changed. See diff above. Aborting. ***"; \
		exit 1 ; \
	fi
endif

nv-readme-open.ids: unpack-stamp
	sed -r -n '/^[0-9]+A?\. SUPPORTED GPUS/,/^Chapter/ s/^(.{41}|.{49}) ([0-9a-fA-F]{4})($$| .*)/10de\2/p' \
		NVIDIA-Linux/README.txt \
		| tr a-f A-F | sort -u > $@
	@set -e -x ; \
	if ! cmp -s debian/$@ $@ ; then \
		diff -u debian/$@ $@ || true ; \
		: "*** Supported PCI IDs have changed. See diff above. Aborting. ***"; \
		exit 1 ; \
	fi

nvidia.ids: nv-readme.ids
	cp $< $@

nvidia-open.ids: nv-readme-open.ids
	cp $< $@

# Reformat the LICENSE to the format needed for debian/copyright.
